Debian Bug report logs - #594189
initramfs-tools: environment variable to disable run_bootloader

version graph

Package: initramfs-tools; Maintainer for initramfs-tools is Debian kernel team <debian-kernel@lists.debian.org>; Source for initramfs-tools is src:initramfs-tools.

Reported by: Colin Watson <cjwatson@ubuntu.com>

Date: Tue, 24 Aug 2010 13:27:02 UTC

Severity: wishlist

Found in version initramfs-tools/0.98

Fixed in version initramfs-tools/0.99

Done: maximilian attems <maks@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, loic.minier@ubuntu.com, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#594189; Package initramfs-tools. (Tue, 24 Aug 2010 13:27:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Colin Watson <cjwatson@ubuntu.com>:
New Bug report received and forwarded. Copy sent to loic.minier@ubuntu.com, Debian kernel team <debian-kernel@lists.debian.org>. (Tue, 24 Aug 2010 13:27:05 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Colin Watson <cjwatson@ubuntu.com>
To: submit@bugs.debian.org
Subject: initramfs-tools: environment variable to disable run_bootloader
Date: Tue, 24 Aug 2010 14:25:05 +0100
Package: initramfs-tools
Version: 0.98
Severity: wishlist
User: ubuntu-devel@lists.ubuntu.com
Usertags: origin-ubuntu maverick

In the case where one is building an image and part of the image build
involves running update-initramfs, it would be useful to have a single
guaranteed way to disable installing any bootloader.  Individual
bootloader hooks in /etc/initramfs-tools/post-update.d/ can do this, but
it would be better to have something central.  Should this be an
environment variable or perhaps a configuration file entry?

(This was originally filed by Loïc Minier as
https://bugs.launchpad.net/bugs/623375.)

Thanks,

-- 
Colin Watson                                       [cjwatson@ubuntu.com]




Information forwarded to debian-bugs-dist@lists.debian.org, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#594189; Package initramfs-tools. (Tue, 24 Aug 2010 13:48:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ben Hutchings <ben@decadent.org.uk>:
Extra info received and forwarded to list. Copy sent to Debian kernel team <debian-kernel@lists.debian.org>. (Tue, 24 Aug 2010 13:48:03 GMT) Full text and rfc822 format available.

Message #10 received at 594189@bugs.debian.org (full text, mbox):

From: Ben Hutchings <ben@decadent.org.uk>
To: Colin Watson <cjwatson@ubuntu.com>, 594189@bugs.debian.org
Subject: Re: Bug#594189: initramfs-tools: environment variable to disable run_bootloader
Date: Tue, 24 Aug 2010 14:45:44 +0100
[Message part 1 (text/plain, inline)]
On Tue, 2010-08-24 at 14:25 +0100, Colin Watson wrote:
> Package: initramfs-tools
> Version: 0.98
> Severity: wishlist
> User: ubuntu-devel@lists.ubuntu.com
> Usertags: origin-ubuntu maverick
> 
> In the case where one is building an image and part of the image build
> involves running update-initramfs, it would be useful to have a single
> guaranteed way to disable installing any bootloader.  Individual
> bootloader hooks in /etc/initramfs-tools/post-update.d/ can do this,

Minus the "-tools"; it's supposed to be shared with any other initramfs
builders.

> but it would be better to have something central.  Should this be an
> environment variable or perhaps a configuration file entry?

So far as I can see, the only reason to override post-update hooks is
that one is cross-building an initramfs.  In that case update-initramfs
is still used for updating the host's initramfs and should continue to
invoke the hooks when doing that.  So this should be a command-line
option and not a configuration option.

Ben.

-- 
Ben Hutchings
Once a job is fouled up, anything done to improve it makes it worse.
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#594189; Package initramfs-tools. (Tue, 24 Aug 2010 13:57:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Colin Watson <cjwatson@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian kernel team <debian-kernel@lists.debian.org>. (Tue, 24 Aug 2010 13:57:09 GMT) Full text and rfc822 format available.

Message #15 received at 594189@bugs.debian.org (full text, mbox):

From: Colin Watson <cjwatson@debian.org>
To: Ben Hutchings <ben@decadent.org.uk>
Cc: 594189@bugs.debian.org
Subject: Re: Bug#594189: initramfs-tools: environment variable to disable run_bootloader
Date: Tue, 24 Aug 2010 14:54:04 +0100
On Tue, Aug 24, 2010 at 02:45:44PM +0100, Ben Hutchings wrote:
> On Tue, 2010-08-24 at 14:25 +0100, Colin Watson wrote:
> > In the case where one is building an image and part of the image build
> > involves running update-initramfs, it would be useful to have a single
> > guaranteed way to disable installing any bootloader.  Individual
> > bootloader hooks in /etc/initramfs-tools/post-update.d/ can do this,
> 
> Minus the "-tools"; it's supposed to be shared with any other initramfs
> builders.

Oops, yes.

> > but it would be better to have something central.  Should this be an
> > environment variable or perhaps a configuration file entry?
> 
> So far as I can see, the only reason to override post-update hooks is
> that one is cross-building an initramfs.  In that case update-initramfs
> is still used for updating the host's initramfs and should continue to
> invoke the hooks when doing that.  So this should be a command-line
> option and not a configuration option.

Consider building a filesystem image inside a chroot which one is about
to build into a live filesystem image with mksquashfs or something.  In
the event that it contains flash-kernel, then the flash-kernel hook
(once such a thing exists; in the meantime, the hardcoded flash-kernel
code in run_bootloader) will write to the host system's flash memory.
(Take another similar example if you disagree with the precise details
of this one; LILO may well have similar properties.)

In this case, changing update-initramfs' command line is likely to be
most inconvenient, as it will be called from postinst scripts and the
like.

-- 
Colin Watson                                       [cjwatson@debian.org]




Information forwarded to debian-bugs-dist@lists.debian.org, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#594189; Package initramfs-tools. (Tue, 24 Aug 2010 14:12:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ben Hutchings <ben@decadent.org.uk>:
Extra info received and forwarded to list. Copy sent to Debian kernel team <debian-kernel@lists.debian.org>. (Tue, 24 Aug 2010 14:12:03 GMT) Full text and rfc822 format available.

Message #20 received at 594189@bugs.debian.org (full text, mbox):

From: Ben Hutchings <ben@decadent.org.uk>
To: Colin Watson <cjwatson@debian.org>, 594189@bugs.debian.org
Subject: Re: Bug#594189: initramfs-tools: environment variable to disable run_bootloader
Date: Tue, 24 Aug 2010 15:09:06 +0100
[Message part 1 (text/plain, inline)]
On Tue, 2010-08-24 at 14:54 +0100, Colin Watson wrote:
[...]
> Consider building a filesystem image inside a chroot which one is about
> to build into a live filesystem image with mksquashfs or something.  In
> the event that it contains flash-kernel, then the flash-kernel hook
> (once such a thing exists; in the meantime, the hardcoded flash-kernel
> code in run_bootloader) will write to the host system's flash memory.
> (Take another similar example if you disagree with the precise details
> of this one; LILO may well have similar properties.)
[...]

If the live filesystem image includes a boot loader package with a
kernel or initramfs hook, you're already running the risk of breaking
the user's machine by installing a boot loader they never wanted.
Protecting the build machine only hides the problem.

Ben.

-- 
Ben Hutchings
Once a job is fouled up, anything done to improve it makes it worse.
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#594189; Package initramfs-tools. (Tue, 24 Aug 2010 14:27:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael Prokop <mika@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian kernel team <debian-kernel@lists.debian.org>. (Tue, 24 Aug 2010 14:27:03 GMT) Full text and rfc822 format available.

Message #25 received at 594189@bugs.debian.org (full text, mbox):

From: Michael Prokop <mika@debian.org>
To: Ben Hutchings <ben@decadent.org.uk>, 594189@bugs.debian.org
Cc: Colin Watson <cjwatson@debian.org>
Subject: Re: Bug#594189: initramfs-tools: environment variable to disable run_bootloader
Date: Tue, 24 Aug 2010 16:24:22 +0200
[Message part 1 (text/plain, inline)]
* Ben Hutchings <ben@decadent.org.uk> [Tue Aug 24, 2010 at 03:09:06PM +0100]:
> On Tue, 2010-08-24 at 14:54 +0100, Colin Watson wrote:

> > Consider building a filesystem image inside a chroot which one is about
> > to build into a live filesystem image with mksquashfs or something.  In
> > the event that it contains flash-kernel, then the flash-kernel hook
> > (once such a thing exists; in the meantime, the hardcoded flash-kernel
> > code in run_bootloader) will write to the host system's flash memory.
> > (Take another similar example if you disagree with the precise details
> > of this one; LILO may well have similar properties.)

> If the live filesystem image includes a boot loader package with a
> kernel or initramfs hook, you're already running the risk of breaking
> the user's machine by installing a boot loader they never wanted.
> Protecting the build machine only hides the problem.

So what's the proper way to disable the kernel or initramfs hook in
your opinion?

I explore the same problem Colin is talking about and deploying
kernel and bootloader packages is something people building live
systems have to deal with, so I'm interested in getting this
situation fixed as well.

regards,
-mika-
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#594189; Package initramfs-tools. (Tue, 24 Aug 2010 14:48:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ben Hutchings <ben@decadent.org.uk>:
Extra info received and forwarded to list. Copy sent to Debian kernel team <debian-kernel@lists.debian.org>. (Tue, 24 Aug 2010 14:48:03 GMT) Full text and rfc822 format available.

Message #30 received at 594189@bugs.debian.org (full text, mbox):

From: Ben Hutchings <ben@decadent.org.uk>
To: Michael Prokop <mika@debian.org>
Cc: 594189@bugs.debian.org, Colin Watson <cjwatson@debian.org>
Subject: Re: Bug#594189: initramfs-tools: environment variable to disable run_bootloader
Date: Tue, 24 Aug 2010 15:45:36 +0100
[Message part 1 (text/plain, inline)]
On Tue, 2010-08-24 at 16:24 +0200, Michael Prokop wrote:
> * Ben Hutchings <ben@decadent.org.uk> [Tue Aug 24, 2010 at 03:09:06PM +0100]:
> > On Tue, 2010-08-24 at 14:54 +0100, Colin Watson wrote:
> 
> > > Consider building a filesystem image inside a chroot which one is about
> > > to build into a live filesystem image with mksquashfs or something.  In
> > > the event that it contains flash-kernel, then the flash-kernel hook
> > > (once such a thing exists; in the meantime, the hardcoded flash-kernel
> > > code in run_bootloader) will write to the host system's flash memory.
> > > (Take another similar example if you disagree with the precise details
> > > of this one; LILO may well have similar properties.)
> 
> > If the live filesystem image includes a boot loader package with a
> > kernel or initramfs hook, you're already running the risk of breaking
> > the user's machine by installing a boot loader they never wanted.
> > Protecting the build machine only hides the problem.
> 
> So what's the proper way to disable the kernel or initramfs hook in
> your opinion?
[...]

You're asking the wrong question here.

What I think you want to know is 'how do I make sure that the boot
loader is not installed where it's not wanted'.  The obvious answer is
'don't install the package'.  The user needs to configure it, in any
case, and why not let them do that through the usual package
configuration mechanism i.e. debconf?

If you insist on installing such a package in the live system then it
needs to support a safe configuration where it won't do anything until
the user configures it to.  It doesn't matter whether it's invoked by
the kernel, initramfs-tools, or anything else.  It *must* require user
configuration.

Ben.

-- 
Ben Hutchings
Once a job is fouled up, anything done to improve it makes it worse.
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#594189; Package initramfs-tools. (Tue, 24 Aug 2010 14:57:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael Prokop <mika@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian kernel team <debian-kernel@lists.debian.org>. (Tue, 24 Aug 2010 14:57:05 GMT) Full text and rfc822 format available.

Message #35 received at 594189@bugs.debian.org (full text, mbox):

From: Michael Prokop <mika@debian.org>
To: Ben Hutchings <ben@decadent.org.uk>
Cc: 594189@bugs.debian.org, Colin Watson <cjwatson@debian.org>
Subject: Re: Bug#594189: initramfs-tools: environment variable to disable run_bootloader
Date: Tue, 24 Aug 2010 16:55:43 +0200
[Message part 1 (text/plain, inline)]
* Ben Hutchings <ben@decadent.org.uk> [Tue Aug 24, 2010 at 03:45:36PM +0100]:
> On Tue, 2010-08-24 at 16:24 +0200, Michael Prokop wrote:
> > * Ben Hutchings <ben@decadent.org.uk> [Tue Aug 24, 2010 at 03:09:06PM +0100]:
> > > On Tue, 2010-08-24 at 14:54 +0100, Colin Watson wrote:

> > > > Consider building a filesystem image inside a chroot which one is about
> > > > to build into a live filesystem image with mksquashfs or something.  In
> > > > the event that it contains flash-kernel, then the flash-kernel hook
> > > > (once such a thing exists; in the meantime, the hardcoded flash-kernel
> > > > code in run_bootloader) will write to the host system's flash memory.
> > > > (Take another similar example if you disagree with the precise details
> > > > of this one; LILO may well have similar properties.)

> > > If the live filesystem image includes a boot loader package with a
> > > kernel or initramfs hook, you're already running the risk of breaking
> > > the user's machine by installing a boot loader they never wanted.
> > > Protecting the build machine only hides the problem.

> > So what's the proper way to disable the kernel or initramfs hook in
> > your opinion?

> You're asking the wrong question here.

> What I think you want to know is 'how do I make sure that the boot
> loader is not installed where it's not wanted'.  The obvious answer is
> 'don't install the package'.  The user needs to configure it, in any
> case, and why not let them do that through the usual package
> configuration mechanism i.e. debconf?

> If you insist on installing such a package in the live system then it
> needs to support a safe configuration where it won't do anything until
> the user configures it to.  It doesn't matter whether it's invoked by
> the kernel, initramfs-tools, or anything else.  It *must* require user
> configuration.

Jepp. But isn't this (possibility for user configuration) exactly
what Colin is requesting?

I'm for example shipping lilo and grub with the live system (so the
binaries as well as its documentation is available to the user), but
nowadays the build process fails due to errors like:

  run-parts: /etc/initramfs/post-update.d//lilo exited with return code 1
[...]
  run-parts: /etc/kernel/postinst.d/zz-lilo exited with return code 1

So the IMHO open question is what's a proper way to disable such
stuff on request?

regards,
-mika-
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#594189; Package initramfs-tools. (Tue, 24 Aug 2010 15:12:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ben Hutchings <ben@decadent.org.uk>:
Extra info received and forwarded to list. Copy sent to Debian kernel team <debian-kernel@lists.debian.org>. (Tue, 24 Aug 2010 15:12:03 GMT) Full text and rfc822 format available.

Message #40 received at 594189@bugs.debian.org (full text, mbox):

From: Ben Hutchings <ben@decadent.org.uk>
To: Michael Prokop <mika@debian.org>
Cc: 594189@bugs.debian.org, Colin Watson <cjwatson@debian.org>, lilo@packages.debian.org, elilo@packages.debian.org
Subject: Re: Bug#594189: initramfs-tools: environment variable to disable run_bootloader
Date: Tue, 24 Aug 2010 16:08:47 +0100
[Message part 1 (text/plain, inline)]
On Tue, 2010-08-24 at 16:55 +0200, Michael Prokop wrote:
> * Ben Hutchings <ben@decadent.org.uk> [Tue Aug 24, 2010 at 03:45:36PM +0100]:
[...]
> > If you insist on installing such a package in the live system then it
> > needs to support a safe configuration where it won't do anything until
> > the user configures it to.  It doesn't matter whether it's invoked by
> > the kernel, initramfs-tools, or anything else.  It *must* require user
> > configuration.
> 
> Jepp. But isn't this (possibility for user configuration) exactly
> what Colin is requesting?

No, he was asking for a way to disable hook invocation (which is
something of a blunt tool).

> I'm for example shipping lilo and grub with the live system (so the
> binaries as well as its documentation is available to the user), but
> nowadays the build process fails due to errors like:
> 
>   run-parts: /etc/initramfs/post-update.d//lilo exited with return code 1
> [...]
>   run-parts: /etc/kernel/postinst.d/zz-lilo exited with return code 1
> 
> So the IMHO open question is what's a proper way to disable such
> stuff on request?

Report a bug on lilo; I suppose it should warn but still 'succeed' if
/etc/lilo.conf is missing.  elilo should do the same.  This is my bug
and I can fix it. :-)  No idea about zipl but I doubt you care about
s390 live media.

Ben.

-- 
Ben Hutchings
Once a job is fouled up, anything done to improve it makes it worse.
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#594189; Package initramfs-tools. (Tue, 24 Aug 2010 15:21:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Stephen Powell <zlinuxman@wowway.com>:
Extra info received and forwarded to list. Copy sent to Debian kernel team <debian-kernel@lists.debian.org>. (Tue, 24 Aug 2010 15:21:09 GMT) Full text and rfc822 format available.

Message #45 received at 594189@bugs.debian.org (full text, mbox):

From: Stephen Powell <zlinuxman@wowway.com>
To: 594189@bugs.debian.org
Cc: Ben Hutchings <ben@decadent.org.uk>, Michael Prokop <mika@debian.org>, Michael Prokop <mika@debian.org>
Subject: Re: Bug#594189: initramfs-tools: environment variable to disable run_bootloader
Date: Tue, 24 Aug 2010 11:18:39 -0400 (EDT)
On Tue, 24 Aug 2010 10:55:43 -0400 (EDT), Michael Prokop <mika@debian.org> wrote:
> Jepp. But isn't this (possibility for user configuration) exactly
> what Colin is requesting?
> 
> I'm for example shipping lilo and grub with the live system (so the
> binaries as well as its documentation is available to the user), but
> nowadays the build process fails due to errors like:
> 
>   run-parts: /etc/initramfs/post-update.d//lilo exited with return code 1
> [...]
>   run-parts: /etc/kernel/postinst.d/zz-lilo exited with return code 1
> 
> So the IMHO open question is what's a proper way to disable such
> stuff on request?

I am not a member of the kernel team.  I'm just an ordinary user.
So I speak with zero authority.  And Ben may have his own ideas that
he wishes to share.  But one way to prevent a hook script from
executing is to remove its executable attribute.  For example,

chmod -x /etc/kernel/postinst.d/zz-lilo
chmod -x /etc/kernel/postrm.d/zz-lilo
chmod -x /etc/initramfs/post-update.d/lilo

This is not supported, of course, nor is it recommended.  But it will
work.  As a general rule I agree with Ben.  If you don't want the hook
scripts to run, don't install the package.  But in special situations,
such as where you want the man page installed for reference purposes
but don't want the package to be used, this is one "solution".
I have used this technique to run my own hook scripts instead of the
package hook scripts without changing the package hook scripts when
the package hook scripts are buggy or incomplete.  (But of course I
open a bug report against the package too.)

-- 
  .''`.     Stephen Powell    
 : :'  :
 `. `'`
   `-




Information forwarded to debian-bugs-dist@lists.debian.org, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#594189; Package initramfs-tools. (Tue, 24 Aug 2010 15:33:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael Prokop <mika@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian kernel team <debian-kernel@lists.debian.org>. (Tue, 24 Aug 2010 15:33:02 GMT) Full text and rfc822 format available.

Message #50 received at 594189@bugs.debian.org (full text, mbox):

From: Michael Prokop <mika@debian.org>
To: Stephen Powell <zlinuxman@wowway.com>
Cc: 594189@bugs.debian.org, Ben Hutchings <ben@decadent.org.uk>
Subject: Re: Bug#594189: initramfs-tools: environment variable to disable run_bootloader
Date: Tue, 24 Aug 2010 17:29:46 +0200
[Message part 1 (text/plain, inline)]
* Stephen Powell <zlinuxman@wowway.com> [Tue Aug 24, 2010 at 11:18:39AM -0400]:
> On Tue, 24 Aug 2010 10:55:43 -0400 (EDT), Michael Prokop <mika@debian.org> wrote:
> > Jepp. But isn't this (possibility for user configuration) exactly
> > what Colin is requesting?

> > I'm for example shipping lilo and grub with the live system (so the
> > binaries as well as its documentation is available to the user), but
> > nowadays the build process fails due to errors like:

> >   run-parts: /etc/initramfs/post-update.d//lilo exited with return code 1
> > [...]
> >   run-parts: /etc/kernel/postinst.d/zz-lilo exited with return code 1

> > So the IMHO open question is what's a proper way to disable such
> > stuff on request?

> I am not a member of the kernel team.  I'm just an ordinary user.
> So I speak with zero authority.  And Ben may have his own ideas that
> he wishes to share.  But one way to prevent a hook script from
> executing is to remove its executable attribute.  For example,

> chmod -x /etc/kernel/postinst.d/zz-lilo
> chmod -x /etc/kernel/postrm.d/zz-lilo
> chmod -x /etc/initramfs/post-update.d/lilo

I'm aware of this, though I'd prefer a clean interface and not hacks. :)

Especially since I'm not aware of a way how to chmod -x the files before
installing the packages that fail during installation then. ;)

regards,
-mika-
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#594189; Package initramfs-tools. (Tue, 24 Aug 2010 15:33:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Stephen Powell <zlinuxman@wowway.com>:
Extra info received and forwarded to list. Copy sent to Debian kernel team <debian-kernel@lists.debian.org>. (Tue, 24 Aug 2010 15:33:04 GMT) Full text and rfc822 format available.

Message #55 received at 594189@bugs.debian.org (full text, mbox):

From: Stephen Powell <zlinuxman@wowway.com>
To: Ben Hutchings <ben@decadent.org.uk>
Cc: Michael Prokop <mika@debian.org>, 594189@bugs.debian.org, Colin Watson <cjwatson@debian.org>, lilo@packages.debian.org, elilo@packages.debian.org
Subject: Re: Bug#594189: initramfs-tools: environment variable to disable run_bootloader
Date: Tue, 24 Aug 2010 11:29:47 -0400 (EDT)
On Tue, 24 Aug 2010 11:08:47 -0400 (EDT), Ben Hutchings wrote:
> 
> Report a bug on lilo; I suppose it should warn but still 'succeed' if
> /etc/lilo.conf is missing.  elilo should do the same.  This is my bug
> and I can fix it. :-)  No idea about zipl but I doubt you care about
> s390 live media.

The last time I checked, the official version of lilo in both squeeze
and sid still did not include any hook scripts.  Joachim Wiedorn's
latest upstream version, 23.0, does include hook scripts; but Joachim
is not the Debian package maintainer for lilo, William Pitcock still is.
And William's official version does not include the hook scripts.
Therefore, opening a Debian bug report against Joachim's unofficial
Debian package is not appropriate.  I do hope that the Technical
Committee eventually gives control of the package to Joachim, but
as far as I know, no decision has yet been made.  (See bug number 587886.)

-- 
  .''`.     Stephen Powell    
 : :'  :
 `. `'`
   `-




Information forwarded to debian-bugs-dist@lists.debian.org, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#594189; Package initramfs-tools. (Tue, 24 Aug 2010 15:39:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael Prokop <mika@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian kernel team <debian-kernel@lists.debian.org>. (Tue, 24 Aug 2010 15:39:03 GMT) Full text and rfc822 format available.

Message #60 received at 594189@bugs.debian.org (full text, mbox):

From: Michael Prokop <mika@debian.org>
To: Stephen Powell <zlinuxman@wowway.com>
Cc: Ben Hutchings <ben@decadent.org.uk>, 594189@bugs.debian.org, Colin Watson <cjwatson@debian.org>, lilo@packages.debian.org, elilo@packages.debian.org
Subject: Re: Bug#594189: initramfs-tools: environment variable to disable run_bootloader
Date: Tue, 24 Aug 2010 17:37:29 +0200
[Message part 1 (text/plain, inline)]
* Stephen Powell <zlinuxman@wowway.com> [Tue Aug 24, 2010 at 11:29:47AM -0400]:
> On Tue, 24 Aug 2010 11:08:47 -0400 (EDT), Ben Hutchings wrote:

> > Report a bug on lilo; I suppose it should warn but still 'succeed' if
> > /etc/lilo.conf is missing.  elilo should do the same.  This is my bug
> > and I can fix it. :-)  No idea about zipl but I doubt you care about
> > s390 live media.

> The last time I checked, the official version of lilo in both squeeze
> and sid still did not include any hook scripts.  Joachim Wiedorn's
> latest upstream version, 23.0, does include hook scripts; but Joachim
> is not the Debian package maintainer for lilo, William Pitcock still is.
> And William's official version does not include the hook scripts.
> Therefore, opening a Debian bug report against Joachim's unofficial
> Debian package is not appropriate.  I do hope that the Technical
> Committee eventually gives control of the package to Joachim, but
> as far as I know, no decision has yet been made.  (See bug number 587886.)

,---- [ aptitude changelog lilo/unstable | head ]
| Get: Changelog of lilo
| lilo (1:22.8-8.2) unstable; urgency=high
|
|   * Non-maintainer upload.
|   * Add kernel and initramfs hook scripts to ensure lilo is reinstalled
|     whenever the kernel or initramfs is updated. (Closes: #590022)
|
|  -- Ben Hutchings <ben@decadent.org.uk>  Tue, 24 Aug 2010 04:25:24 +0100
|
| lilo (1:22.8-8.1) unstable; urgency=low
`----

regards,
-mika-
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#594189; Package initramfs-tools. (Tue, 24 Aug 2010 15:48:10 GMT) Full text and rfc822 format available.

Acknowledgement sent to Stephen Powell <zlinuxman@wowway.com>:
Extra info received and forwarded to list. Copy sent to Debian kernel team <debian-kernel@lists.debian.org>. (Tue, 24 Aug 2010 15:48:10 GMT) Full text and rfc822 format available.

Message #65 received at 594189@bugs.debian.org (full text, mbox):

From: Stephen Powell <zlinuxman@wowway.com>
To: Michael Prokop <mika@debian.org>
Cc: 594189@bugs.debian.org, Ben Hutchings <ben@decadent.org.uk>
Subject: Re: Bug#594189: initramfs-tools: environment variable to disable run_bootloader
Date: Tue, 24 Aug 2010 11:47:13 -0400 (EDT)
On Tue, 24 Aug 2010 11:29:46 -0400 (EDT), Michael Prokop wrote:
> 
> I'm aware of this, though I'd prefer a clean interface and not hacks. :)
> 
> Especially since I'm not aware of a way how to chmod -x the files before
> installing the packages that fail during installation then. ;)
> 

I haven't been following the thread; so I don't know precisely what
installation problem you are having.  But
Joachim's version of lilo does contain a "bashism" in it's initramfs hook
which may be the cause of the installation failure.  It uses
"substring expansion", which works with the Bourne Again Shell (bash),
but not with the Bourne Shell or clones thereof (dash, ash, etc.).
This is partly my fault, since his initramfs hook is based on a template
which I provided which has the same problem.  I have reported the problem
to him, but so far I have not received a reply.

If this is the cause of the installation failure, temporarily change the
symlink /bin/sh to point to bash instead of dash.  This will allow the
package to install.  Then, change "#!/bin/sh" on line 1 of
/etc/initramfs/post-update.d/lilo to "#!/bin/bash" and change your
symlink /bin/sh to point back to dash, or whatever it used to be
pointing to.  But maybe this is not why you are having installation
problems.

-- 
  .''`.     Stephen Powell    
 : :'  :
 `. `'`
   `-




Information forwarded to debian-bugs-dist@lists.debian.org, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#594189; Package initramfs-tools. (Tue, 24 Aug 2010 15:57:19 GMT) Full text and rfc822 format available.

Acknowledgement sent to Stephen Powell <zlinuxman@wowway.com>:
Extra info received and forwarded to list. Copy sent to Debian kernel team <debian-kernel@lists.debian.org>. (Tue, 24 Aug 2010 15:57:20 GMT) Full text and rfc822 format available.

Message #70 received at 594189@bugs.debian.org (full text, mbox):

From: Stephen Powell <zlinuxman@wowway.com>
To: Michael Prokop <mika@debian.org>
Cc: Ben Hutchings <ben@decadent.org.uk>, 594189@bugs.debian.org, Colin Watson <cjwatson@debian.org>, lilo@packages.debian.org, elilo@packages.debian.org
Subject: Re: Bug#594189: initramfs-tools: environment variable to disable run_bootloader
Date: Tue, 24 Aug 2010 11:54:42 -0400 (EDT)
On Tue, 24 Aug 2010 11:37:29 -0400 (EDT), Michael Prokop wrote:
> 
> ,---- [ aptitude changelog lilo/unstable | head ]
> | Get: Changelog of lilo
> | lilo (1:22.8-8.2) unstable; urgency=high
> |
> |   * Non-maintainer upload.
> |   * Add kernel and initramfs hook scripts to ensure lilo is reinstalled
> |     whenever the kernel or initramfs is updated. (Closes: #590022)
> |
> |  -- Ben Hutchings <ben@decadent.org.uk>  Tue, 24 Aug 2010 04:25:24 +0100
> |
> | lilo (1:22.8-8.1) unstable; urgency=low
> `----

Aha!  Nice work, Ben.  I didn't check far enough.  I used this link

http://packages.debian.org/search?keywords=lilo&searchon=names&suite=unstable&section=all

and saw that the current version was still 1:22.8-8.1.  Either the package
hasn't been uploaded yet or the web page is not in sync with the repository.

-- 
  .''`.     Stephen Powell    
 : :'  :
 `. `'`
   `-




Information forwarded to debian-bugs-dist@lists.debian.org, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#594189; Package initramfs-tools. (Tue, 24 Aug 2010 15:57:21 GMT) Full text and rfc822 format available.

Acknowledgement sent to Colin Watson <cjwatson@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian kernel team <debian-kernel@lists.debian.org>. (Tue, 24 Aug 2010 15:57:21 GMT) Full text and rfc822 format available.

Message #75 received at 594189@bugs.debian.org (full text, mbox):

From: Colin Watson <cjwatson@debian.org>
To: Ben Hutchings <ben@decadent.org.uk>
Cc: Michael Prokop <mika@debian.org>, 594189@bugs.debian.org, lilo@packages.debian.org, elilo@packages.debian.org
Subject: Re: Bug#594189: initramfs-tools: environment variable to disable run_bootloader
Date: Tue, 24 Aug 2010 16:55:28 +0100
On Tue, Aug 24, 2010 at 04:08:47PM +0100, Ben Hutchings wrote:
> On Tue, 2010-08-24 at 16:55 +0200, Michael Prokop wrote:
> > * Ben Hutchings <ben@decadent.org.uk> [Tue Aug 24, 2010 at 03:45:36PM +0100]:
> > > If you insist on installing such a package in the live system then it
> > > needs to support a safe configuration where it won't do anything until
> > > the user configures it to.  It doesn't matter whether it's invoked by
> > > the kernel, initramfs-tools, or anything else.  It *must* require user
> > > configuration.
> > 
> > Jepp. But isn't this (possibility for user configuration) exactly
> > what Colin is requesting?
> 
> No, he was asking for a way to disable hook invocation (which is
> something of a blunt tool).

Actually, what I want is a consistent way to disable bootloader
invocation for all bootloaders, without necessarily requiring the
bootloader package not to be installed (since that's sometimes extremely
awkward to arrange).  Exactly where this goes I can't say I mind.  If
the result is an extension to the bootloader/kernel policy that needs to
be implemented in each bootloader package, that would be fine too.

> > I'm for example shipping lilo and grub with the live system (so the
> > binaries as well as its documentation is available to the user), but
> > nowadays the build process fails due to errors like:
> > 
> >   run-parts: /etc/initramfs/post-update.d//lilo exited with return code 1
> > [...]
> >   run-parts: /etc/kernel/postinst.d/zz-lilo exited with return code 1
> > 
> > So the IMHO open question is what's a proper way to disable such
> > stuff on request?
> 
> Report a bug on lilo; I suppose it should warn but still 'succeed' if
> /etc/lilo.conf is missing.  elilo should do the same.  This is my bug
> and I can fix it. :-)  No idea about zipl but I doubt you care about
> s390 live media.

What I specifically do not want is for top-level client programs to have
to keep track of the different ways to ensure that each individual
bootloader is disabled.

-- 
Colin Watson                                       [cjwatson@debian.org]




Information forwarded to debian-bugs-dist@lists.debian.org, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#594189; Package initramfs-tools. (Tue, 24 Aug 2010 16:21:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael Prokop <mika@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian kernel team <debian-kernel@lists.debian.org>. (Tue, 24 Aug 2010 16:21:03 GMT) Full text and rfc822 format available.

Message #80 received at 594189@bugs.debian.org (full text, mbox):

From: Michael Prokop <mika@debian.org>
To: Stephen Powell <zlinuxman@wowway.com>
Cc: 594189@bugs.debian.org, Ben Hutchings <ben@decadent.org.uk>
Subject: Re: Bug#594189: initramfs-tools: environment variable to disable run_bootloader
Date: Tue, 24 Aug 2010 18:18:39 +0200
[Message part 1 (text/plain, inline)]
* Stephen Powell <zlinuxman@wowway.com> [Tue Aug 24, 2010 at 11:47:13AM -0400]:
> On Tue, 24 Aug 2010 11:29:46 -0400 (EDT), Michael Prokop wrote:

> > I'm aware of this, though I'd prefer a clean interface and not hacks. :)

> > Especially since I'm not aware of a way how to chmod -x the files before
> > installing the packages that fail during installation then. ;)

> I haven't been following the thread; so I don't know precisely what
> installation problem you are having.  But
> Joachim's version of lilo does contain a "bashism" in it's initramfs hook
> which may be the cause of the installation failure.  It uses
> "substring expansion", which works with the Bourne Again Shell (bash),
> but not with the Bourne Shell or clones thereof (dash, ash, etc.).
> This is partly my fault, since his initramfs hook is based on a template
> which I provided which has the same problem.  I have reported the problem
> to him, but so far I have not received a reply.

> If this is the cause of the installation failure, temporarily change the
> symlink /bin/sh to point to bash instead of dash.  This will allow the
> package to install.  Then, change "#!/bin/sh" on line 1 of
> /etc/initramfs/post-update.d/lilo to "#!/bin/bash" and change your
> symlink /bin/sh to point back to dash, or whatever it used to be
> pointing to.  But maybe this is not why you are having installation
> problems.

No, it's not because of the bashism but because of:

| Fatal: Cannot open: /etc/lilo.conf

(I just verified that once more).

See http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=594189#35
and http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=594189#40
and my bugreport against the lilo package -> #594213

regards,
-mika-
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#594189; Package initramfs-tools. (Tue, 24 Aug 2010 16:27:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael Prokop <mika@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian kernel team <debian-kernel@lists.debian.org>. (Tue, 24 Aug 2010 16:27:06 GMT) Full text and rfc822 format available.

Message #85 received at 594189@bugs.debian.org (full text, mbox):

From: Michael Prokop <mika@debian.org>
To: Colin Watson <cjwatson@debian.org>
Cc: Ben Hutchings <ben@decadent.org.uk>, 594189@bugs.debian.org
Subject: Re: Bug#594189: initramfs-tools: environment variable to disable run_bootloader
Date: Tue, 24 Aug 2010 18:23:56 +0200
[Message part 1 (text/plain, inline)]
(Removed [e]lilo@packages.debian.org from Cc)

* Colin Watson <cjwatson@debian.org> [Tue Aug 24, 2010 at 04:55:28PM +0100]:
> On Tue, Aug 24, 2010 at 04:08:47PM +0100, Ben Hutchings wrote:
> > On Tue, 2010-08-24 at 16:55 +0200, Michael Prokop wrote:
> > > * Ben Hutchings <ben@decadent.org.uk> [Tue Aug 24, 2010 at 03:45:36PM +0100]:
> > > > If you insist on installing such a package in the live system then it
> > > > needs to support a safe configuration where it won't do anything until
> > > > the user configures it to.  It doesn't matter whether it's invoked by
> > > > the kernel, initramfs-tools, or anything else.  It *must* require user
> > > > configuration.

> > > Jepp. But isn't this (possibility for user configuration) exactly
> > > what Colin is requesting?

> > No, he was asking for a way to disable hook invocation (which is
> > something of a blunt tool).

> Actually, what I want is a consistent way to disable bootloader
> invocation for all bootloaders, without necessarily requiring the
> bootloader package not to be installed (since that's sometimes extremely
> awkward to arrange).  Exactly where this goes I can't say I mind.  If
> the result is an extension to the bootloader/kernel policy that needs to
> be implemented in each bootloader package, that would be fine too.

ACK, I'd like something like that as well.

> > > I'm for example shipping lilo and grub with the live system (so the
> > > binaries as well as its documentation is available to the user), but
> > > nowadays the build process fails due to errors like:

> > >   run-parts: /etc/initramfs/post-update.d//lilo exited with return code 1
> > > [...]
> > >   run-parts: /etc/kernel/postinst.d/zz-lilo exited with return code 1

> > > So the IMHO open question is what's a proper way to disable such
> > > stuff on request?

> > Report a bug on lilo; I suppose it should warn but still 'succeed' if
> > /etc/lilo.conf is missing.  elilo should do the same.  This is my bug
> > and I can fix it. :-)  No idea about zipl but I doubt you care about
> > s390 live media.

> What I specifically do not want is for top-level client programs to have
> to keep track of the different ways to ensure that each individual
> bootloader is disabled.

FullACK.

Sorry for the AOL style mail :) - I just want to express that I fully
agree with Colin's wish. It's exactly what I consider interesting for
live systems (and chroots) without having to work around any
possible dangerous package.

regards,
-mika-
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#594189; Package initramfs-tools. (Wed, 25 Aug 2010 04:48:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ben Hutchings <ben@decadent.org.uk>:
Extra info received and forwarded to list. Copy sent to Debian kernel team <debian-kernel@lists.debian.org>. (Wed, 25 Aug 2010 04:48:05 GMT) Full text and rfc822 format available.

Message #90 received at 594189@bugs.debian.org (full text, mbox):

From: Ben Hutchings <ben@decadent.org.uk>
To: Colin Watson <cjwatson@debian.org>
Cc: Michael Prokop <mika@debian.org>, 594189@bugs.debian.org, lilo@packages.debian.org, elilo@packages.debian.org
Subject: Re: Bug#594189: initramfs-tools: environment variable to disable run_bootloader
Date: Wed, 25 Aug 2010 05:44:32 +0100
[Message part 1 (text/plain, inline)]
On Tue, 2010-08-24 at 16:55 +0100, Colin Watson wrote:
> On Tue, Aug 24, 2010 at 04:08:47PM +0100, Ben Hutchings wrote:
> > On Tue, 2010-08-24 at 16:55 +0200, Michael Prokop wrote:
> > > * Ben Hutchings <ben@decadent.org.uk> [Tue Aug 24, 2010 at 03:45:36PM +0100]:
> > > > If you insist on installing such a package in the live system then it
> > > > needs to support a safe configuration where it won't do anything until
> > > > the user configures it to.  It doesn't matter whether it's invoked by
> > > > the kernel, initramfs-tools, or anything else.  It *must* require user
> > > > configuration.
> > > 
> > > Jepp. But isn't this (possibility for user configuration) exactly
> > > what Colin is requesting?
> > 
> > No, he was asking for a way to disable hook invocation (which is
> > something of a blunt tool).
> 
> Actually, what I want is a consistent way to disable bootloader
> invocation for all bootloaders, without necessarily requiring the
> bootloader package not to be installed (since that's sometimes extremely
> awkward to arrange).  Exactly where this goes I can't say I mind.  If
> the result is an extension to the bootloader/kernel policy that needs to
> be implemented in each bootloader package, that would be fine too.
[...]

OK, so something like this:

"Boot loader packages must be installable on the filesystem in a
disabled state where they will not write to the boot sector or other
non-filesystem storage.  While a boot loader is disabled, any kernel and
initramfs hooks it includes must do nothing except (optionally) printing
a warning that the boot loader is disabled, and must exit successfully."

Ben.

-- 
Ben Hutchings
Once a job is fouled up, anything done to improve it makes it worse.
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#594189; Package initramfs-tools. (Sat, 28 Aug 2010 03:33:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ben Hutchings <ben@decadent.org.uk>:
Extra info received and forwarded to list. Copy sent to Debian kernel team <debian-kernel@lists.debian.org>. (Sat, 28 Aug 2010 03:33:06 GMT) Full text and rfc822 format available.

Message #95 received at 594189@bugs.debian.org (full text, mbox):

From: Ben Hutchings <ben@decadent.org.uk>
To: Colin Watson <cjwatson@debian.org>, Bastian Blank <waldi@debian.org>, Michael Prokop <mika@debian.org>
Cc: 594189@bugs.debian.org, lilo@packages.debian.org, elilo@packages.debian.org
Subject: Re: Bug#594189: initramfs-tools: environment variable to disable run_bootloader
Date: Sat, 28 Aug 2010 04:27:53 +0100
[Message part 1 (text/plain, inline)]
On Wed, 2010-08-25 at 05:44 +0100, Ben Hutchings wrote:
[...]
> OK, so something like this:
> 
> "Boot loader packages must be installable on the filesystem in a
> disabled state where they will not write to the boot sector or other
> non-filesystem storage.  While a boot loader is disabled, any kernel and
> initramfs hooks it includes must do nothing except (optionally) printing
> a warning that the boot loader is disabled, and must exit successfully."

I'm assuming the above is acceptable to everyone, so:

- I added this to the policy in kernel-handbook 1.0.8
- I implemented this in lilo (in response to #594479)
- I filed a bug on elilo (#594650)

Bastian, is this an issue for s390-tools or is zipl the only plausible
way to load the kernel?

Ben.

-- 
Ben Hutchings
Once a job is fouled up, anything done to improve it makes it worse.
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#594189; Package initramfs-tools. (Sat, 28 Aug 2010 04:39:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Bdale Garbee <bdale@gag.com>:
Extra info received and forwarded to list. Copy sent to Debian kernel team <debian-kernel@lists.debian.org>. (Sat, 28 Aug 2010 04:39:03 GMT) Full text and rfc822 format available.

Message #100 received at 594189@bugs.debian.org (full text, mbox):

From: Bdale Garbee <bdale@gag.com>
To: Ben Hutchings <ben@decadent.org.uk>, Colin Watson <cjwatson@debian.org>, Bastian Blank <waldi@debian.org>, Michael Prokop <mika@debian.org>
Cc: 594189@bugs.debian.org, lilo@packages.debian.org, elilo@packages.debian.org
Subject: Re: Bug#594189: initramfs-tools: environment variable to disable run_bootloader
Date: Fri, 27 Aug 2010 22:37:41 -0600
[Message part 1 (text/plain, inline)]
On Sat, 28 Aug 2010 04:27:53 +0100, Ben Hutchings <ben@decadent.org.uk> wrote:
> - I filed a bug on elilo (#594650)

I'll be traveling for the next week with limited net access and time.
If you want this attended to quickly, a suitable patch would be welcomed.

Bdale
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#594189; Package initramfs-tools. (Sat, 28 Aug 2010 08:36:12 GMT) Full text and rfc822 format available.

Acknowledgement sent to Colin Watson <cjwatson@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian kernel team <debian-kernel@lists.debian.org>. (Sat, 28 Aug 2010 08:36:12 GMT) Full text and rfc822 format available.

Message #105 received at 594189@bugs.debian.org (full text, mbox):

From: Colin Watson <cjwatson@debian.org>
To: Ben Hutchings <ben@decadent.org.uk>
Cc: Michael Prokop <mika@debian.org>, 594189@bugs.debian.org, lilo@packages.debian.org, elilo@packages.debian.org
Subject: Re: Bug#594189: initramfs-tools: environment variable to disable run_bootloader
Date: Sat, 28 Aug 2010 09:35:41 +0100
On Wed, Aug 25, 2010 at 05:44:32AM +0100, Ben Hutchings wrote:
> On Tue, 2010-08-24 at 16:55 +0100, Colin Watson wrote:
> > Actually, what I want is a consistent way to disable bootloader
> > invocation for all bootloaders, without necessarily requiring the
> > bootloader package not to be installed (since that's sometimes extremely
> > awkward to arrange).  Exactly where this goes I can't say I mind.  If
> > the result is an extension to the bootloader/kernel policy that needs to
> > be implemented in each bootloader package, that would be fine too.
> [...]
> 
> OK, so something like this:
> 
> "Boot loader packages must be installable on the filesystem in a
> disabled state where they will not write to the boot sector or other
> non-filesystem storage.  While a boot loader is disabled, any kernel and
> initramfs hooks it includes must do nothing except (optionally) printing
> a warning that the boot loader is disabled, and must exit successfully."

This is a good start, but it doesn't specify *how* boot loader packages
are to be disabled.  I think that this needs to be consistent across
boot loaders.

-- 
Colin Watson                                       [cjwatson@debian.org]




Information forwarded to debian-bugs-dist@lists.debian.org, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#594189; Package initramfs-tools. (Sat, 28 Aug 2010 13:51:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ben Hutchings <ben@decadent.org.uk>:
Extra info received and forwarded to list. Copy sent to Debian kernel team <debian-kernel@lists.debian.org>. (Sat, 28 Aug 2010 13:51:05 GMT) Full text and rfc822 format available.

Message #110 received at 594189@bugs.debian.org (full text, mbox):

From: Ben Hutchings <ben@decadent.org.uk>
To: Colin Watson <cjwatson@debian.org>
Cc: Michael Prokop <mika@debian.org>, 594189@bugs.debian.org, lilo@packages.debian.org, elilo@packages.debian.org
Subject: Re: Bug#594189: initramfs-tools: environment variable to disable run_bootloader
Date: Sat, 28 Aug 2010 14:47:56 +0100
[Message part 1 (text/plain, inline)]
On Sat, 2010-08-28 at 09:35 +0100, Colin Watson wrote:
> On Wed, Aug 25, 2010 at 05:44:32AM +0100, Ben Hutchings wrote:
> > On Tue, 2010-08-24 at 16:55 +0100, Colin Watson wrote:
> > > Actually, what I want is a consistent way to disable bootloader
> > > invocation for all bootloaders, without necessarily requiring the
> > > bootloader package not to be installed (since that's sometimes extremely
> > > awkward to arrange).  Exactly where this goes I can't say I mind.  If
> > > the result is an extension to the bootloader/kernel policy that needs to
> > > be implemented in each bootloader package, that would be fine too.
> > [...]
> > 
> > OK, so something like this:
> > 
> > "Boot loader packages must be installable on the filesystem in a
> > disabled state where they will not write to the boot sector or other
> > non-filesystem storage.  While a boot loader is disabled, any kernel and
> > initramfs hooks it includes must do nothing except (optionally) printing
> > a warning that the boot loader is disabled, and must exit successfully."
> 
> This is a good start, but it doesn't specify *how* boot loader packages
> are to be disabled.  I think that this needs to be consistent across
> boot loaders.

That would be good, but it is already a problem you have to deal with in
creating a live distribution (e.g. you don't want an invocation of
'lilo' without arguments to install on some random disk chosen at build
time).  I believe it is out of scope for this policy.

For what it's worth, I think the basic answer is 'don't create a
configuration file'.  However, elilo will do that on installation by
default, so you need to set debconf variable elilo/runme to false.

Ben.

-- 
Ben Hutchings
Once a job is fouled up, anything done to improve it makes it worse.
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#594189; Package initramfs-tools. (Sat, 28 Aug 2010 14:03:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Colin Watson <cjwatson@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian kernel team <debian-kernel@lists.debian.org>. (Sat, 28 Aug 2010 14:03:03 GMT) Full text and rfc822 format available.

Message #115 received at 594189@bugs.debian.org (full text, mbox):

From: Colin Watson <cjwatson@debian.org>
To: Ben Hutchings <ben@decadent.org.uk>
Cc: Michael Prokop <mika@debian.org>, 594189@bugs.debian.org, lilo@packages.debian.org, elilo@packages.debian.org
Subject: Re: Bug#594189: initramfs-tools: environment variable to disable run_bootloader
Date: Sat, 28 Aug 2010 15:00:39 +0100
On Sat, Aug 28, 2010 at 02:47:56PM +0100, Ben Hutchings wrote:
> On Sat, 2010-08-28 at 09:35 +0100, Colin Watson wrote:
> > This is a good start, but it doesn't specify *how* boot loader packages
> > are to be disabled.  I think that this needs to be consistent across
> > boot loaders.
> 
> That would be good, but it is already a problem you have to deal with in
> creating a live distribution (e.g. you don't want an invocation of
> 'lilo' without arguments to install on some random disk chosen at build
> time).  I believe it is out of scope for this policy.
> 
> For what it's worth, I think the basic answer is 'don't create a
> configuration file'.  However, elilo will do that on installation by
> default, so you need to set debconf variable elilo/runme to false.

Speaking as the grub2 maintainer, this is not particularly helpful there
as the packaging creates a configuration file on installation if
requested based on debconf interaction.  Of course I can invent some way
to change this but I would like that to be consistent with other boot
loaders - that being part of the point of this report!

-- 
Colin Watson                                       [cjwatson@debian.org]




Information forwarded to debian-bugs-dist@lists.debian.org, Debian kernel team <debian-kernel@lists.debian.org>:
Bug#594189; Package initramfs-tools. (Sat, 28 Aug 2010 14:12:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ben Hutchings <ben@decadent.org.uk>:
Extra info received and forwarded to list. Copy sent to Debian kernel team <debian-kernel@lists.debian.org>. (Sat, 28 Aug 2010 14:12:03 GMT) Full text and rfc822 format available.

Message #120 received at 594189@bugs.debian.org (full text, mbox):

From: Ben Hutchings <ben@decadent.org.uk>
To: Colin Watson <cjwatson@debian.org>
Cc: Michael Prokop <mika@debian.org>, 594189@bugs.debian.org, lilo@packages.debian.org, elilo@packages.debian.org
Subject: Re: Bug#594189: initramfs-tools: environment variable to disable run_bootloader
Date: Sat, 28 Aug 2010 15:09:04 +0100
[Message part 1 (text/plain, inline)]
On Sat, 2010-08-28 at 15:00 +0100, Colin Watson wrote:
> On Sat, Aug 28, 2010 at 02:47:56PM +0100, Ben Hutchings wrote:
> > On Sat, 2010-08-28 at 09:35 +0100, Colin Watson wrote:
> > > This is a good start, but it doesn't specify *how* boot loader packages
> > > are to be disabled.  I think that this needs to be consistent across
> > > boot loaders.
> > 
> > That would be good, but it is already a problem you have to deal with in
> > creating a live distribution (e.g. you don't want an invocation of
> > 'lilo' without arguments to install on some random disk chosen at build
> > time).  I believe it is out of scope for this policy.
> > 
> > For what it's worth, I think the basic answer is 'don't create a
> > configuration file'.  However, elilo will do that on installation by
> > default, so you need to set debconf variable elilo/runme to false.
> 
> Speaking as the grub2 maintainer, this is not particularly helpful there
> as the packaging creates a configuration file on installation if
> requested based on debconf interaction.  Of course I can invent some way
> to change this but I would like that to be consistent with other boot
> loaders - that being part of the point of this report!

This doesn't apply to grub2 since it will only update its configuration
and not reinstall into the boot sector.  I hope I've made this clear
when updating the kernel handbook; please review 7.2 and 7.3 of
<http://kernel-handbook.alioth.debian.org/ch-update-hooks.html>.

Ben.

-- 
Ben Hutchings
Once a job is fouled up, anything done to improve it makes it worse.
[signature.asc (application/pgp-signature, inline)]

Added tag(s) pending. Request was from maximilian attems <maks@debian.org> to control@bugs.debian.org. (Thu, 12 May 2011 12:24:12 GMT) Full text and rfc822 format available.

Reply sent to maximilian attems <maks@debian.org>:
You have taken responsibility. (Fri, 13 May 2011 12:36:13 GMT) Full text and rfc822 format available.

Notification sent to Colin Watson <cjwatson@ubuntu.com>:
Bug acknowledged by developer. (Fri, 13 May 2011 12:36:13 GMT) Full text and rfc822 format available.

Message #127 received at 594189-close@bugs.debian.org (full text, mbox):

From: maximilian attems <maks@debian.org>
To: 594189-close@bugs.debian.org
Subject: Bug#594189: fixed in initramfs-tools 0.99
Date: Fri, 13 May 2011 12:32:35 +0000
Source: initramfs-tools
Source-Version: 0.99

We believe that the bug you reported is fixed in the latest version of
initramfs-tools, which is due to be installed in the Debian FTP archive:

initramfs-tools_0.99.dsc
  to main/i/initramfs-tools/initramfs-tools_0.99.dsc
initramfs-tools_0.99.tar.gz
  to main/i/initramfs-tools/initramfs-tools_0.99.tar.gz
initramfs-tools_0.99_all.deb
  to main/i/initramfs-tools/initramfs-tools_0.99_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 594189@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
maximilian attems <maks@debian.org> (supplier of updated initramfs-tools package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Wed, 11 May 2011 23:38:18 +0200
Source: initramfs-tools
Binary: initramfs-tools
Architecture: source all
Version: 0.99
Distribution: unstable
Urgency: low
Maintainer: Debian kernel team <debian-kernel@lists.debian.org>
Changed-By: maximilian attems <maks@debian.org>
Description: 
 initramfs-tools - tools for generating an initramfs
Closes: 338405 454934 501969 502792 506540 594189 596742 603858 603903 606806 609964 611046 612633 619670 620924 621803 625224 626446
Changes: 
 initramfs-tools (0.99) unstable; urgency=low
 .
   Release "scarpe rotte e pur bisogna andar"
 .
   [ maximilian attems ]
   * [ce45cd0] update-initramfs: Show the mkinitramfs on error message.
   * [5b84e5b] maintainer-notes.html: Fix email to send patches to.
   * [ec6a77f] doc: s/ressources/resources/
   * [3c717fa] initramfs-tools: preinst use blkid for uuid generation if around.
     (Closes: #609964)
   * [8e2ffcd] postinst cleanup very old dpkg trigger comparison.
   * [78cdb26] mkinitramfs: Add support for xz compression. (closes: #626446)
   * [f5b8347] hook-functions: Cleanup ref to ide-disk.
   * [6cab0ec] initramfs-tools: cleanup any usplash traces. (closes: #620924)
   * [08d4895] initramfs-tools: Remove mkinitramfs-kpkg.
     (Closes: #454934, #502792)
   * [0ed6376] initramfs-tools: add hid_sunplus to listed keyboard drivers.
   * [5f53d3b] init: load netconsole after loading network drivers.
     Thanks Ferenc Wagner <wferi@niif.hu> (Closes: #596742)
   * [7ff2998] debian/copyright: Update authorlist and year attribution.
   * [e789cdd] maintainer-notes: Use git dch --multimaint-merge on examples.
   * [17296ff] dep_add_modules: Use hidden_dep_add_modules for ubifs.
   * [3d44bfb] hidden_dep_add: Use mika's variadic function from $2 on.
   * [8f8299d] mkinitramfs: copy over on build instead of using symlink tree.
     (Closes: #338405, #506540)
   * [f5afa6a] mkinitramfs: Add lib search path + run full ldconfig in
     initramfs. (Closes: #612633, #619670)
   * [259ad09] mkinitramfs: creat /run initramfs directory.
   * [5add333] initramfs-tools: init mount /run tmpfs.
   * [74109b9] init: No need to touch /dev/.initramfs.
   * [8e7620a] hook-functions: xhci-hcd got renamed. (Closes: #625224)
     Thanks to Matthew Wilcox <willy@linux.intel.com>
 .
   [ Tim Small ]
   * [1fe9f78] Add Documentation for modules=list in initramfs.conf(5).
     (Closes: #603903)
 .
   [ Ben Hutchings ]
   * [c018886] kernel hooks: Treat missing version argument as an error.
   * [58ee42c] kernel hooks: Enable error-exit (sh -e).
   * [7866542] update-initramfs: Depend on kernel hook scripts rather than
     $ramdisk invocation.
   * [43fe8e6] update-initramfs: Remove support for 'do_bootloader' and
     specific boot loaders. (closes: #594189)
 .
   [ Gianluigi Tiesi ]
   * [9c25269] mkinitramfs: misleading message in verbose mode.
     (Closes: #611046)
 .
   [ Timo Juhani Lindfors ]
   * [871ffe7] initramfs-tools: Make panic message visible even if panic=
     is used.
   * [2525b00] initramfs-tools: Inform the user about reboot on panic=.
 .
   [ Michael Prokop ]
   * [465a5f1] hidden_dep_add_modules(): make it dynamically to support more
     than 3 arguments as well.
   * [3323930] Use --check=crc32 option for xz compression.
     Thanks to Ulrich Dangel <mru@grml.org>
   * [bedf1e3] Use -8 for compression with xz.
   * [adce374] docs: fix wording ("allows *one* to") to make lintian happy.
   * [ecbc54a] Bump Standards-Version to 3.9.2.
 .
   [ Evan Broder ]
   * [ad1a594] initramfs-tools: Fix handling of numeric root= arguments to be
      udev-friendly. (Closes: #501969, #606806)
 .
   [ Christian Hofstaedtler ]
   * [e34eca4] init: move /proc after moving other filesystems.
 .
   [ Roger Leigh ]
   * [10990ab] init: Preserve state on old boxes without /run on rootfs.
   * [4d08c2e] init: sync mount options with the defaults in initscripts.
     (Closes: #621803)
   * [20c43ce] init: Don't use "none" as a mount fsname (Closes: #603858)
 .
   [ Michael Tokarev ]
   * [ec83abd] mkinitramfs: No need to warn about md-root busybox dep.
Checksums-Sha1: 
 bfe072cb51cc028aba1e7fefbd067690dba4ce22 965 initramfs-tools_0.99.dsc
 3efd8d3f5ddeed373af53f029a60e5a169cf7fe8 83627 initramfs-tools_0.99.tar.gz
 c18db8de2b3413bf49fc42dc0c05188f4c7e45b6 89558 initramfs-tools_0.99_all.deb
Checksums-Sha256: 
 e86ca92ea5febebc0eae4d2ced831c3bca787de30e01614973f0d81d4112d659 965 initramfs-tools_0.99.dsc
 8db379fcbbc4dd81c2f22c955b1c1ff4883a9f7b9187d037f7b19752b0c56226 83627 initramfs-tools_0.99.tar.gz
 83e6ebc00d318f5d2a1c7da01b70d3196c0067dc9aa74142bfddd7959931871e 89558 initramfs-tools_0.99_all.deb
Files: 
 524ea435f52c3ed4d5769e6a567983bb 965 utils optional initramfs-tools_0.99.dsc
 d8b2711f25f287724d954f8c495de5f2 83627 utils optional initramfs-tools_0.99.tar.gz
 06201e844ab0d57325274df01c306b62 89558 utils optional initramfs-tools_0.99_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.11 (GNU/Linux)

iEYEARECAAYFAk3NIWUACgkQeW7Lc5tEHqj8+gCfcJQgxk9b6fK5aPfqfA4t7Ws1
zzYAn08PN8VceR+cAalWwL50zvuqQER3
=z9JG
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Tue, 21 Jun 2011 07:39:30 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Mon Apr 21 11:02:41 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.